import router from './router'
import store from './store'
import { Message } from 'element-ui'
import NProgress from 'nprogress' // 进度条
import 'nprogress/nprogress.css' // 进度条样式
import { getToken } from '@/utils/auth' // 引入getToken函数
import getPageTitle from '@/utils/get-page-title'  // 把路由meta的title属性值设置成页面标题

NProgress.configure({ showSpinner: false }) // 进度条末尾加载环显示隐藏配置

const whiteList = ['/login'] // 没有登录可以去的路径

router.beforeEach(async (to, from, next) => {
  // 进度条开始
  NProgress.start()

  // 设置页面标题
  document.title = getPageTitle(to.meta.title)

  // 确定用户是否已经登录（是否有token）
  const hasToken = getToken()

  if (hasToken) {
    if (to.path === '/login') {
      // 如果已经登录还要去登录页重定向到首页
      next({ path: '/' })
      // 进度条结束
      NProgress.done()
    } else {
      // 确定是否有用户信息
      const hasGetUserInfo = store.getters.name

      if (hasGetUserInfo) {
        // 如果有放行
        next()
      } else {
        // 没有重新获取用户信息
        // next({ path: '/login' })
        try {
          // await store.dispatch('user/getInfo')
          next()
        } catch (error) {
          // 移除token，转到登录页面重新登录
          await store.dispatch('user/resetToken')
          Message.error({
            message: error || "出现错误，请稍后再试"
          })
          next(`/login?redirect=${to.path}`)
          NProgress.done()
        }
      }
    }
  }
  //  没有登录
  else {
    // 判断去的路径是否是登录页
    if (whiteList.indexOf(to.path) !== -1) {
      // 是则放行
      next()
    } else {
      // 不是的话 其他没有访问权限的页面被重定向到登录页面
      next(`/login?redirect=${to.path}`)
      NProgress.done()
    }
  }
})

router.afterEach(() => {
  // 每次路由跳转结束让进度条结束
  NProgress.done()
})
